<template>
  <div class="flex flex-col h-fit w-full border border-primary rounded-md">
    <div class="bg-primary p-2 text-white flex flex-row gap-2 justify-between items-center">
      <p class="grow">{{ position.executivePosition }} von {{ position.start }} bis {{ position.end ?? "heute" }}</p>
      <PencilIcon v-if="can('update', 'club', 'member')" class="w-5 h-5 cursor-pointer" @click="openEditModal" />
      <TrashIcon v-if="can('delete', 'club', 'member')" class="w-5 h-5 cursor-pointer" @click="openDeleteModal" />
    </div>
    <div v-if="position.note" class="p-2">
      <p v-if="position.note">Notiz: {{ position.note }}</p>
    </div>
  </div>
</template>

<script setup lang="ts">
import { defineAsyncComponent, defineComponent, markRaw, type PropType } from "vue";
import { mapState, mapActions } from "pinia";
import type { MemberExecutivePositionViewModel } from "@/viewmodels/admin/memberExecutivePosition.models";
import { PencilIcon, TrashIcon } from "@heroicons/vue/24/outline";
import { useModalStore } from "@/stores/modal";
import { useAbilityStore } from "@/stores/ability";
</script>

<script lang="ts">
export default defineComponent({
  props: {
    position: {
      type: Object as PropType<MemberExecutivePositionViewModel>,
      default: {},
    },
  },
  computed: {
    ...mapState(useAbilityStore, ["can"]),
  },
  methods: {
    ...mapActions(useModalStore, ["openModal"]),
    openEditModal() {
      this.openModal(
        markRaw(
          defineAsyncComponent(() => import("@/components/admin/club/member/MemberExecutivePositionEditModal.vue"))
        ),
        this.position.id
      );
    },
    openDeleteModal() {
      this.openModal(
        markRaw(
          defineAsyncComponent(() => import("@/components/admin/club/member/MemberExecutivePositionDeleteModal.vue"))
        ),
        this.position.id
      );
    },
  },
});
</script>
